using Avalonia.Controls;
using Avalonia.Interactivity;
using System.IO;
using System.Text.RegularExpressions;
using System;
using static System.Runtime.InteropServices.JavaScript.JSType;
using HarfBuzzSharp;
using System.Collections.Generic;
using System.Linq;
using Avalonia.Media;

namespace WorkWithAvolonia
{
    public struct People
    {
        public string Surname;
        public string Name;
        public string Patranomic;
        public string Telephone;
        public string Gender;
        public int Birthday;
        public string BirthMonth;
        public int BirthYear;
        public string BirthdayOfWeek;
        public string DrevGorop;
    }
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        
        public void DrevGoroskop(int Month, int Day, ref string DrevGorop)
        {
            if ((Month == 12 && Day >= 24) || (Month == 1 && Day <= 30))
            {
                DrevGorop = " (, , )";
            }
            else if ((Month == 1 && Day >= 31) || (Month == 2 && Day <= 28))
            {
                DrevGorop = "";
            }
            else if (Month == 3)
            {
                DrevGorop = "";
            }
            else if (Month == 4)
            {
                DrevGorop = "";
            }
            else if (Month == 5 && (Day >= 1 && Day <= 14))
            {
                DrevGorop = " ()";
            }
            else if ((Month == 5 && Day >= 15) || (Month == 6 && Day <= 2))
            {
                DrevGorop = "";
            }
            else if (Month == 6 && (Day >= 3 && Day <= 12))
            {
                DrevGorop = "";
            }
            else if ((Month == 6 && (Day >= 13 && Day != 24)) || (Month == 7 && Day <= 6))
            {
                DrevGorop = "";
            }
            else if (Month == 6 && Day == 24)
            {
                DrevGorop = " ";
            }
            else if (Month == 7 && (Day >= 7 && Day <= 31))
            {
                DrevGorop = "";
            }
            else if (Month == 8 && (Day >= 1 && Day <= 28))
            {
                DrevGorop = "";
            }
            else if ((Month == 8 && Day >= 29) || (Month == 9 && Day <= 13))
            {
                DrevGorop = "";
            }
            else if (Month == 9 && (Day >= 14 && Day <= 27))
            {
                DrevGorop = "";
            }
            else if ((Month == 9 && Day >= 28) || (Month == 10 && Day <= 15))
            {
                DrevGorop = "";
            }
            else if ((Month == 10 && Day >= 16) || (Month == 11 && Day <= 8))
            {
                DrevGorop = "";
            }
            else if (Month == 11 && (Day >= 9 && Day <= 28))
            {
                DrevGorop = "";
            }
            else if ((Month == 11 && Day >= 29) || (Month == 12 && Day <= 23))
            {
                DrevGorop = "";
            }
        }
        
        private async void WriteFile(object sender, RoutedEventArgs e)
        {
            People person = new People();
            string error; bool flag1 = false, flag2 = false, flag3 = false;            
            Regex regS = new Regex(@"^[-ߨ][-]{2,}$");
            person.Surname = tbSurname.Text;
            if (regS.IsMatch(person.Surname))
            {
                Error1.IsVisible = true;
                Error1.Text = " ";
                flag1 = true;
            }
            else
            {
                Error1.IsVisible = true;
                Error1.Text = "     ;       ; -       ";
            }
            person.Name = tbName.Text;
            Regex regN = new Regex(@"^[-ߨ][-]{1,}$");
            if (regN.IsMatch(person.Name))
            {
                Error2.IsVisible = true;
                Error2.Text = " ";
                flag2 = true;
            }
            else
            {
                Error2.IsVisible = true;
                Error2.Text = "     ;       ; -       ";
            }
            person.Patranomic = tbPatronymic.Text;
            person.Telephone = tbTelephone.Text;
            Regex regT = new Regex(@"^8\(\d{3}\)\d{3}-\d{2}-\d{2}$");
            if (regT.IsMatch(person.Telephone))
            {
                Error3.IsVisible = true;
                Error3.Text = " ";
                flag3 = true;
            }
            else
            {
                Error3.IsVisible = true;
                Error3.Text = "       8(XXX)XXX-XX-XX";
            }
            person.Birthday = Convert.ToInt32(tbBirthday.Text);
            person.BirthYear = Convert.ToInt32(tbBirthYear.Text);            

            switch (cbBirthMonth.SelectedIndex)
            {
                case 1: person.BirthMonth = ""; break;
                case 2: person.BirthMonth = ""; break;
                case 3: person.BirthMonth = ""; break;
                case 4: person.BirthMonth = ""; break;
                case 5: person.BirthMonth = ""; break;
                case 6: person.BirthMonth = ""; break;
                case 7: person.BirthMonth = ""; break;
                case 8: person.BirthMonth = ""; break;
                case 9: person.BirthMonth = ""; break;
                case 10: person.BirthMonth = ""; break;
                case 11: person.BirthMonth = ""; break;
                case 12: person.BirthMonth = ""; break;
            }

            if (rbM.IsChecked == true) person.Gender = "";
            if (rbW.IsChecked == true) person.Gender = "";

            DateTime BirthdayDate = new DateTime(person.BirthYear, DateTime.ParseExact(person.BirthMonth, "MMMM", null).Month, person.Birthday);
            person.BirthdayOfWeek = BirthdayDate.DayOfWeek.ToString();
            switch (person.BirthdayOfWeek)
            {
                case "Monday": person.BirthdayOfWeek = ""; break;
                case "Tuesday": person.BirthdayOfWeek = ""; break;
                case "Wednesday": person.BirthdayOfWeek = ""; break;
                case "Thursday": person.BirthdayOfWeek = ""; break;
                case "Friday": person.BirthdayOfWeek = ""; break;
                case "Saturday": person.BirthdayOfWeek = ""; break;
                case "Sunday": person.BirthdayOfWeek = ""; break;
            }

            DateTime DayAndMonth = new DateTime(person.BirthYear, DateTime.ParseExact(person.BirthMonth, "MMMM", null).Month, person.Birthday);
            int Month = DayAndMonth.Month;
            int Day = DayAndMonth.Day;
            person.DrevGorop = "";

            DrevGoroskop(Month, Day, ref person.DrevGorop);            

            if (flag1 && flag2 && flag3)
            {
                using (StreamWriter sw = new StreamWriter("User.csv", true, System.Text.Encoding.UTF8))
                {
                    ShowMessage1.IsVisible = false;
                    sw.WriteLine(person.Surname + ";" + person.Name + ";" + person.Patranomic + ";" + person.Telephone + ";" + person.BirthdayOfWeek + ";" + person.Birthday + ";" + person.BirthMonth + ";" + person.BirthYear + ";" + person.Gender + ";" + person.DrevGorop + ";");
                }
            }
            else
            {
                ShowMessage1.IsVisible = true; 
                ShowMessage1.Text = "    ";
            }

            if (flag1 && flag2 && flag3)
            {
                ShowMessage2.IsVisible = true;
                ShowMessage2.Text = "    ";
            }
            else
            {
                ShowMessage2.IsVisible = true;
                ShowMessage2.Text = "     ";
            }
        }

        private async void Back(object sender, RoutedEventArgs e)
        {
            ShowUser.IsVisible = false;
            WriteUser.IsVisible = true;
        }

        public SolidColorBrush color(string Gender)
        {
            switch (Gender)
            {
                case "":
                    return new SolidColorBrush(Color.FromArgb(230, 174, 247, 161));
                case "":
                    return new SolidColorBrush(Color.FromArgb(230, 142, 217, 245));                
                default:
                    return new SolidColorBrush(Color.FromRgb(0, 0, 0));
            }
        }

        private async void ShowFile(object sender, RoutedEventArgs e)
        {
            People person = new People();
            ShowUser.IsVisible = true;
            WriteUser.IsVisible = false;

            List<People> peopleList = new List<People>();

            using (StreamReader sr = new StreamReader("User.csv"))
            {
                while(!sr.EndOfStream)
                {
                    string[] array = sr.ReadLine().Split(";");
                    peopleList.Add(new People()
                    {
                        Surname = array[0],
                        Name = array[1],
                        Patranomic = array[2],
                        Telephone = array[3],
                        Gender = array[8],
                        Birthday = Convert.ToInt32(array[5]),
                        BirthMonth = array[6],
                        BirthYear = Convert.ToInt32(array[7]),
                        BirthdayOfWeek = array[4],
                        DrevGorop = array[9],
                    });                    
                }
            }
            List<People> alfpor = peopleList.OrderBy(p => p.Surname).ThenBy(p => p.Name).ToList();

            string SurnameName;
            foreach (People item in alfpor)
            {
                SurnameName = item.Surname + " " + item.Name;
                TextBlock tbSurnameName = new TextBlock()
                {
                    Text = "  : " + SurnameName,          
                };
                TextBlock tbPatronymic = new TextBlock()
                {
                    Text = ": " + item.Patranomic,
                };
                TextBlock tbTelephone = new TextBlock()
                {
                    Text = " : " + item.Telephone,
                };
                TextBlock tbBirthdayOfWeek = new TextBlock()
                {
                    Text = "   : " + item.BirthdayOfWeek,
                };
                DateTime BirthDate = new DateTime(item.BirthYear, DateTime.ParseExact(item.BirthMonth, "MMMM", null).Month, item.Birthday);
                TextBlock tbBirthDate = new TextBlock()
                {                    
                    Text = " : " + BirthDate.ToShortDateString(),
                };
                TextBlock tbGender = new TextBlock()
                {
                    Text = ": " + item.Gender,
                };                
                TextBlock DrevGorop = new TextBlock()
                {
                    Text = "  : " + item.DrevGorop,
                };

                StackPanel spUsers = new StackPanel();
                spUsers.HorizontalAlignment = Avalonia.Layout.HorizontalAlignment.Left;
                spUsers.Children.Add(tbSurnameName);
                spUsers.Children.Add(tbPatronymic);
                spUsers.Children.Add(tbTelephone);
                spUsers.Children.Add(tbBirthdayOfWeek);
                spUsers.Children.Add(tbBirthDate);
                spUsers.Children.Add(tbGender);
                spUsers.Children.Add(DrevGorop);

                Border border = new Border();
                border.Background = color(item.Gender);
                border.BorderBrush = Brushes.Aqua;
                border.BorderThickness = new Avalonia.Thickness(2);
                border.CornerRadius = new Avalonia.CornerRadius(15);
                border.Margin = new Avalonia.Thickness(5);
                border.Padding = new Avalonia.Thickness(10);

                border.Child = spUsers;

                ShowUser.Children.Add(border);
            }
        }
    }
}